static char sccsid[]="@(#)%E% P.Hoad@ee.surrey.ac.uk %I% %M%";
/*
 * Copyright (C) 1992, 1993, 1994, Paul D. Hoad This file is part of the Xmgf
 * Software. For conditions of distribution and use, see the accompanying
 * README file.
 *
 * Vision Speech and Signal Processing Group . Dept. of Electronic Engineering.
 * University of Surrey. Guildford, Surrey. England. Phone: +44 483 300800
 * Ext 2753 Email: P.Hoad@ee.surrey.ac.uk
 */

#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>

#include "XmgfStruct.h"
#include "XmgfGlobal.h"
#include "XmgfDefines.h"
#include "InitX.h"
#include "GUI.h"
#include "Mouse.h"
#include "callbacks.h"

/* |/////////////////////////////oOo\\\\\\\\\\\\\\\\\\\\\\\\\\\| */
/* |/////////////////////////////oOo\\\\\\\\\\\\\\\\\\\\\\\\\\\| */
void 
XmgfEvent(w, closure, Xmgfevent, done)
Widget  w;
XtPointer closure;
XEvent *Xmgfevent;
int    *done;
{
  static int CurrentButton = 0;


  switch (Xmgfevent->type) {
   case Expose:{
      UpDateVisibleCB(w, (caddr_t)NULL, (caddr_t)NULL);
    }
    break;
   case ButtonPress:{
      XButtonEvent *but_event = (XButtonEvent *) Xmgfevent;
      int     x, y;
      Window  win;

      win = but_event->window;
      x = but_event->x;
      y = but_event->y;

      switch (but_event->button) {
       case Button1:
	PointerSelectSetCB(w, (caddr_t)NULL, (caddr_t)NULL);
	CurrentButton = 1;
	break;
       case Button2:
	CurrentButton = 2;
	break;
       case Button3:
	CurrentButton = 3;
	break;
       default:
	CurrentButton = 0;
	break;
      }
    }
    break;
   case ButtonRelease:{
      XButtonEvent *but_event = (XButtonEvent *) Xmgfevent;
      int     x, y;
      Window  win;

      win = but_event->window;
      x = but_event->x;
      y = but_event->y;
      switch (but_event->button) {
       case Button1:
	CurrentButton = 0;
	break;
       case Button2:
	CurrentButton = 0;
	break;
       case Button3:
	CurrentButton = 0;
	UpDateVisibleCB(w, (caddr_t)NULL, (caddr_t)NULL);
	break;
       default:
	CurrentButton = 0;
	break;
      }
    }
    break;
   case MotionNotify:{
      switch (CurrentButton) {
       case 1:
	CurrentButton = 1;
	break;
       case 2:
	CurrentButton = 2;
	UpdatePositionCB(w, (caddr_t)NULL, (caddr_t)NULL);
	break;
       case 3:
	CurrentButton = 3;
	UpdateScaleCB(w, (caddr_t)NULL, (caddr_t)NULL);
	break;
       default:
	CurrentButton = 0;
	UpdateXYCB(w, (caddr_t)NULL, (caddr_t)NULL);
	break;
      }
    }
    break;
   case ResizeRequest:{
	fprintf(stderr,"Resize Request Made\n");
    } 
    break;
   default:
    break;			/* ignore unexpected events */
  }
}

void
XmgfEventList(w, closure, Xmgfevent, done)
Widget  w;
XtPointer closure;
XEvent *Xmgfevent;
int    *done;
{
  	switch (Xmgfevent->type) {
 	case ButtonPress:{
         XButtonEvent *but_event = (XButtonEvent *) Xmgfevent;

         switch (but_event->button) {
          case Button1:
	   SetCB(w,(caddr_t)SELECTSET,(caddr_t)NULL);
           break;
          case Button2:
	   SetCB(w,(caddr_t)SELECTSET,(caddr_t)NULL);
	   SetCB(w,(caddr_t)ARDEL,(caddr_t)NULL);
           break;
          case Button3:
	   SetCB(w,(caddr_t)SELECTSET,(caddr_t)NULL);
	   SetCB(w,(caddr_t)ARDRAW,(caddr_t)NULL);
           break;
          default:
           break;
         }
	   break;
	}
	case EnterNotify:{
        XmgfMessage("1st Button Select, 2nd Button Delete, 3rd Button Draw");
	break;
	}
	default: break;
	}
}

void 
XmgfWindowEvent(w, closure, Xmgfevent, done)
Widget  w;
XtPointer closure;
XEvent *Xmgfevent;
int    *done;
{
	int PosX,PosY;
	unsigned int WinWidth,WinHeight,BorderWidth,WinDepth;
	Window Root;
        switch (Xmgfevent->type) {
	case ConfigureNotify:{
	XGetGeometry(theDisplay,XtWindow(toplevel),
		&Root,&PosX,&PosY,&WinWidth,&WinHeight,&BorderWidth,&WinDepth);
#if DEBUG
        fprintf(stderr,"Resize Request Made\n");
        fprintf(stderr,"%d %d %d %d\n",PosX,PosY,WinWidth,WinHeight);
#endif
	if (WinWidth<800) WinWidth=800;
	if (WinHeight<740) WinHeight=740;
	DrawingAreaWidth=(WinWidth-160);
	DrawingAreaHeight=(WinHeight-180);
	Midx = DrawingAreaWidth/2;
	Midy = DrawingAreaHeight/2;
/*	DestroyBuff();*/
/*	CreateBuff(w_Orth, DrawingAreaWidth, DrawingAreaHeight);*/
/*	XtResizeWidget(submainpane,DrawingAreaWidth+160,DrawingAreaHeight+100,0);*/
	XtResizeWidget(LeftRC,WinWidth,DrawingAreaHeight+100,0);
        }
	break;
	}
}

	
